Recent

Author Topic: [solved] debian/ubuntu + qt5  (Read 2168 times)

andyH

  • Jr. Member
  • **
  • Posts: 99
[solved] debian/ubuntu + qt5
« on: January 17, 2022, 03:51:06 pm »
My application currently runs with gtk2, but as it is getting long in the tooth I thought I look at switching to QT. Googled for instructions.

Running Linux Mint 20.3 and lazarus 2.0.10.

Downloaded and installed:
  • libqt5pas1 v2.9
  • libqt5pas-dev v2.9
Note - not the versions in the repos, they are v2.6.

In lazarus: Projects -> Project Options -> Additions & Overrides -> Set "Value qt5"

Compiled okay, ran and not quite what we want! See screenshots. Most of my objects have disappeared. Screenshots show it all. Each tab on the main window is a TBasePanel = class(TPanel)  that has the TCheckListBoxes and labels.

On start the application reads the system, the window for that displays ok with QT - another screenshot.

Thought this would be straightforward, what am I missing?

Also note that under set "LCLWidgetType" GTK3 is an option. I thought lazarus didn't support GTK3 which is why I'm looking at QT?

EDIT - tried Set "Value GTK3" and got an error while linking
« Last Edit: February 11, 2022, 01:03:50 pm by andyH »

MarkMLl

  • Hero Member
  • *****
  • Posts: 4693
Re: debian/ubuntu + qt5
« Reply #1 on: January 17, 2022, 07:22:44 pm »
Note - not the versions in the repos, they are v2.6.

Sounds like you've broken your system. Does "DLL Hell" ring a bell?

If you really do want 2.9 then I suggest upgrading your distro to a "bleeding edge" version that uses it consistently. Or investigating whether you can build a Docker image using that version: I've had success in the past SSHing into Docker and running Lazarus etc. over the resulting tunnel.

And as for GTK3: it's one of those things that everybody aspires to, like "integrity and humility in government" (sorry, I'm in the UK and at present we've got a problem).

MarkMLl
MT+86 & Turbo Pascal v1 on CCP/M-86, multitasking with LAN & graphics in 128Kb.
Pet hate: people who boast about the size and sophistication of their computer.
GitHub repositories: https://github.com/MarkMLl?tab=repositories

andyH

  • Jr. Member
  • **
  • Posts: 99
Re: debian/ubuntu + qt5
« Reply #2 on: January 17, 2022, 08:19:53 pm »
Quote
Does "DLL Hell" ring a bell?
No, but "dependency hell" does, been there done it  :(

I'll remove the v2.9 versions and see if the 2.6 versions in the repos make any difference, I suspect not. I'll stick with GTK2 for the time being. It is probably a significant re-write to get it to work with QT and it's +7,000LOC.  A future version...

The writing is on the wall for GTK2, don't think it is installed in Ubuntu 21, so (not) coming to a distro near you soon. Seems like GTK3 has been coming "real soon" now for a couple of years with lazarus. Really don't want to switch, I see C++ as the only viable alternative, but rather not, like lazarus/pascal, I'm comfortable.

Also UK, and I can only agree.

andyH

  • Jr. Member
  • **
  • Posts: 99
Re: debian/ubuntu + qt5
« Reply #3 on: February 11, 2022, 01:03:31 pm »

 

TinyPortal © 2005-2018